/**
 * @class {util4js.ArgumentException}
 * @extends {util4js.Exception}
 */
var ArgumentException = $class({

  /**
   * @memberOf {util4js.ArgumentException}
   * @public
   * @construct {util4js.ArgumentException}
   */
  __construct__: function () {
    this.name = "ArgumentException";
    this.message = "An argument exception has occured";
    this.__paramName = null;
  },

  /**
   * @memberOf {util4js.ArgumentException}
   * @public
   * @property {String} paramName
   */
  paramName: {
    get: function () {
      return this.__paramName;
    },
    set: function (value) {
      return this.__paramName = value;
    } 
  },

  /**
   * @memberOf {util4js.ArgumentException}
   * @public
   * @overridden
   * @method toString
   * @retuns {String}
   */
  toString: function () {
    return this.name + ": " + this.message + " (Parameter: " + this.paramName  + ")";
  }

}, Exception);

exports.ArgumentException = ArgumentException;

