/**
 * @abstract
 * @class {util4js.Component}
 * @extends {util4js.Object}
 */
var Component = $abstract_class({

  /**
   * @memberOf {util4js.Component}
   * @public
   * @constructor {util4js.Component}
   */
  __construct__: function () {
    this.__eventDispatcher = new EventDispathcer();
  },

  /**
   * @memberOf {util4js.Component}
   * @public
   * @method addEventListener
   * @param {String} type
   * @param {Function} listener
   */
  addEventListener: function (type, listener) { 
    this.__eventDispatcher.add(type, listener);
  },

  /**
   * @memberOf {util4js.Component}
   * @public
   * @method removeEventListener
   * @param {String} type
   * @param {Function} listener
   */
  removeEventListener: function (type, listener) { 
    this.__eventDispatcher.remove(type, listener);
  },

  /**
   * @memberOf {util4js.Component}
   * @public
   * @method dispatchEvent
   * @param {util4js.Event} e 
   */ 
  dispatchEvent: function (e) { 
    this.__eventDispatcher.dispatch($create(Event, e));
  },

  /**
   * @memberOf {util4js.Component}
   * @public
   * @overridden
   * @method toString
   * @returns {String}
   */
  toString: function () {
    return "util4js.Component";
  }

}, Object, IEventTarget);

exports.Component = Component;

