/**
 * @class {util4js.Event}
 * @extends {util4js.Object}
 */
var Event = $class({

  /**
   * @memberOf {util4js.Event}
   * @public
   * @constructor {util4js.Event}
   */
  __construct__: function () {
    this.__target = null;
    this.__type = "";
  },

  /**
   * @memberOf {util4js.Event}
   * @public
   * @property {String} type
   */
  type: {
    get: function () {
      return this.__type;
    }, 
    set: function (value) {
      this.__type = value;
    }  
  },

  /**
   * @memberOf {util4js.Event}
   * @public
   * @property {Object} target
   */
  target: {
    get: function () {
      return this.__target;
    },
    set: function (value) {
      this.__target = value;
    }
  },

  /**
   * @memberOf {util4js.Event}
   * @public
   * @overridden
   * @method toString
   * @returns {String}
   */
  toString: function () {
    return this.type;
  }

}, Object);

exports.Event = Event;

