/**
 * @class {util4js.Exception}
 * @extends {util4js.Object}
 */
var Exception = $class({

  /**
   * @memberOf {util4js.Exception}
   * @public
   * @constructor {util4js.Exception}
   */
  __construct__: function () {
    this.__name = "Exception";
    this.__message = "An exception has occured";
    this.__innerException = null;
  },

  /**
   * @memberOf {util4js.Exception}
   * @public
   * @property {String} name
   */
  name: {
    get: function () {
      return this.__name;
    },
    set: function (value) {
      this.__name = value;
    }
  },

  /**
   * @memberOf {util4js.Exception}
   * @public
   * @property {String} message
   */
  message: {
    get: function () {
      return this.__message;
    },
    set: function (value) {
      this.__message = value;
    } 
  },

  /**
   * @memberOf {util4js.Exception}
   * @public
   * @property {Object} innerException
   */
  innerException: {
    get: function () {
      return this.__innerException;
    },
    set: function (value) {
      this.__innerException = value;
    }
  }, 

  /**
   * @memberOf {util4js.Exception}
   * @public
   * @overridden
   * @method toString
   * @retuns {String}
   */
  toString: function () {
    return this.name + ": " + this.message;
  }

}, Object);

exports.Exception = Exception;

