/**
 * @extension {util4js.IIteratable}
 * @method forEach
 * @param {Function} callback
 */
$extend(IIteratable, "forEach", function (callback) {
  if (callback) {
    var iterator = this.iterator();
    while (iterator.hasNext()) {
      callback(iterator.next());
    } 
  } 
});

/**
 * @extension {util4js.IIteratable}
 * @method count
 * @returns {Number}
 */
$extend(IIteratable, "count", function () {
  var count = 0;
  var iterator = this.iterator();
  while (iterator.next()) {
    count++;  
  }
  return count;
});

/**
 * @extension {util4js.IIteratable}
 * @method first
 * @returns {Object}
 */
$extend(IIteratable, "first", function () {
  var iterator = this.iterator();
  var first = null;
  while (iterator.hasNext()) {
    first = iterator.next();
    break;
  }
  return first;
});

/**
 * @extension {util4js.IIteratable}
 * @method last
 * @returns {Object}
 */
$extend(IIteratable, "last", function () {
  var iterator = this.iterator();
  var last = null;
  while (iterator.hasNext()) {
    last = iterator.next();
  }
  return last;
});

/**
 * @extension {util4js.IIteratable}
 * @method toArray
 * @returns {Object[]}
 */
$extend(IIteratable, "toArray", function () {
  var array = [];
  var iterator = this.iterator();  
  while (iterator.hasNext()) {
    array.push(iterator.next());
  }
  return array;
});

/**
 * @extension {util4js.IIteratable}
 * @method toList
 * @returns {util4js.IList}
 */
$extend(IIteratable, "toList", function () {
  var list = new List();
  while (iterator.hasNext()) {
    list.add(iterator.next());
  }
  return list; 
});

