/**
 * @class {util4js.KeyValuePair}
 * @extends {util4js.Object}
 */
var KeyValuePair = $class({

  /**
   * @memberOf {util4js.KeyValuePair}
   * @public
   * @constructor {util4js.KeyValuePair}
   * @param {Object} key
   * @param {Object} value
   */
  __construct__: function (key, value) {
    if (!key) {
      throw new ArgumentNullException("Key is not set");
    }
    this.__key = key;
    this.__value = value;
  },

  /**
   * @memberOf {util4js.KeyValuePair}
   * @public
   * @property {Object} key
   */
  key: {
    get: function () {
      return this.__key;
    }
  },

  /**
   * @memberOf {util4js.KeyValuePair}
   * @public
   * @property {Object} value
   */
  value: {
    get: function () {
      return this.__value;
    },
    set: function (value) {
      this.__value = value;
    }
  }

}, Object);

exports.KeyValuePair = KeyValuePair;

