/**
 * @class {util4js.Object}
 */
var Object = $class({

  __static__: {
 
    /**
     * @memberOf {util4js.Object}
     * @static
     * @private
     * @field {Integer} __counter
     */
    __counter: 0,

    /**
     * @memberOf {util4js.Object}
     * @static
     * @public
     * @method equals
     * @param {Object} a
     * @param {Object} b
     */
    equals: function (a, b) {
      if (a === b) {
        return true;
      }
      if (!a || !b) {
        return false;
      }
      return a.equals(b);
    }
    
  },

  /**
   * @memberOf {util4js.Object}
   * @public
   * @constructor {util4js.Object}
   */
  __construct__: function (props) {
    this.__hashCode = ++Object.__counter;
  },

  /**
   * @memberOf {util4js.Object}
   * @public
   * @method equals
   * @param {Object} obj
   */
  equals: function (obj) {
    if (!obj) {
      return false;
    } 
    return this === obj; 
  },

  /**
   * @memberOf {util4js.Object}
   * @public
   * @method getHashCode
   */
  getHashCode: function () {
    return this.__hashCode;
  },

  /**
   * @memberOf {util4js.Object}
   * @public
   * @method toString
   * @returns {String}
   */
  toString: function () {
    return "util4js.Object";
  }

});

exports.Object = Object;

