$namespace("util4js");var util4js=$module(function(exports,g"use strict";lobal){var Object=$class({__static__:{__counter:0,equals:function(a,b){if(a===b){return true;}if(!a||!b){return false;}return a.equals(b);}},__construct__:function(props){this.__hashCode=++Object.__counter;},equals:function(obj){if(!obj){return false;}return this===obj;},getHashCode:function(){return this.__hashCode;},toString:function(){return"util4js.Object";}});exports.Object=Object;var Exception=$class({__construct__:function(){this.__name="Exception";this.__message="An exception has occured";this.__innerException=null;},name:{get:function(){return this.__name;},set:function(value){this.__name=value;}},message:{get:function(){return this.__message;},set:function(value){this.__message=value;}},innerException:{get:function(){return this.__innerException;},set:function(value){this.__innerException=value;}},toString:function(){return this.name+": "+this.message;}},Object);exports.Exception=Exception;var ArgumentException=$class({__construct__:function(){this.name="ArgumentException";this.message="An argument exception has occured";this.__paramName=null;},paramName:{get:function(){return this.__paramName;},set:function(value){return this.__paramName=value;}},toString:function(){return this.name+": "+this.message+" (Parameter: "+this.paramName+")";}},Exception);exports.ArgumentException=ArgumentException;var ArgumentNullException=$class({__construct__:function(){this.name="ArgumentNullException";this.message="An argument null exception has occured";}},ArgumentException);exports.ArgumentNullException=ArgumentNullException;var IndexOutOfRangeException=$class({__construct__:function(){this.name="IndexOutOfRangeException";this.message="Index out of range exception has occured";},},Exception);exports.IndexOutOfRangeException=IndexOutOfRangeException;var IIterator=$interface({hasNext:function(){},next:function(){},reset:function(){}});exports.IIterator=IIterator;var IIteratable=$interface({iterator:function(){}});exports.IIteratable=IIteratable;var Iterator=$class({__construct__:function(items){this.__index=-1;if(!items){throw new ArgumentNullException({paramName:"items"});}if(items instanceof Array){this.__items=items;}else{throw new ArgumentException({paramName:"items",message:"Parameter type is invalid"});}},hasNext:function(){return this.__index+1<this.__items.length;},next:function(){if(!this.hasNext()){return null;}this.__index++;return this.__items[this.__index];},reset:function(){this.__index=-1;},toString:function(){return"util4js.Iterator";}},Object,IIterator);exports.Iterator=Iterator;var IList=$interface({length:{get:function(){}},add:function(item){},remove:function(item){},clear:function(){},contains:function(item){},get:function(index){},set:function(index,item){},insert:function(index,item){},removeAt:function(index){},indexOf:function(item){}},IIteratable);exports.IList=IList;var List=$class({__construct__:function(items){if(items){if(items instanceof Array){this.__items=items;}else{throw new ArgumentException({paramName:"items",message:"Parameter type is invalid"});}}else{this.__items=[];}},toString:function(){return"util4js.List";},iterator:function(){return new Iterator(this.__items);},length:{get:function(){return this.__items.length;}},add:function(item){this.__items.push(item);},remove:function(item){var index=this.__items.indexOf(item);if(index!=-1){this.__items.splice(index,1);return true;}return false;},clear:function(){this.__items=[];},contains:function(item){return this.__items.indexOf(item)!=-1;},get:function(index){if(index<0||index>=this.count){throw new IndexOutOfRangeException();}return this.__items[index];},set:function(index,item){if(index<0||index>=this.count){throw new IndexOutOfRangeException();}this.__items[index]=item;},insert:function(index,item){if(index<0||index>this.count){throw new IndexOutOfRangeException();}this.__items.splice(index,0,item);},removeAt:function(index){if(index<0||index>=this.count){throw new IndexOutOfRangeException();}this.__items.splice(index,1);return true;},indexOf:function(item){if($is(item,Object)){for(var i=0;i<this.__items.length;i++){if(Object.equals(this.__items[i],item)){return i;}}return -1;}else{return this.__items.indexOf(item);}}},Object,IList);exports.List=List;var ISet=$interface({length:{get:function(){}},add:function(item){},remove:function(item){},clear:function(){},contains:function(item){}},ISet);exports.ISet=ISet;var SetIterator=$class({__construct__:function(items){this.__index=-1;if(!items){throw new ArgumentNullException({paramName:"items"});}this.__items=items;this.__hashCodes=global.Object.keys(items);},hasNext:function(){return this.__index+1<this.__hashCodes.length;},next:function(){if(!this.hasNext()){return null;}this.__index++;return this.__items[this.__hashCodes[this.__index]];},reset:function(){this.__index=-1;},toString:function(){return"util4js.SetIterator";}},Object,IIterator);exports.SetIterator=SetIterator;var Set=$class({__construct__:function(items){this.__length=0;this.__items=global.Object.create(null);if(items){if(items instanceof Array){for(var i=0;i<items.length;i++){this.add(items[i]);}}else{throw new ArgumentException({paramName:"items",message:"Parameter type is invalid"});}}},toString:function(){return"util4js.Set";},iterator:function(){return new SetIterator(this.__items);},length:{get:function(){return this.__length;}},add:function(item){var hashCode=this.__getItemHashCode(item);if(!this.contains(hashCode)){this.__items[hashCode]=item;this.__length++;}else{throw new ArgumentException({paramName:"item",message:"A dublicated item can't be added to the set"});}},remove:function(item){var hashCode=this.__getItemHashCode(item);if(this.contains(hashCode)){delete this.__items[hashCode];this.__length--;return true;}return false;},clear:function(){this.__length=0;this.__items={};},contains:function(item){var hashCode=this.__getItemHashCode(item);return(hashCode in this.__items);},__getItemHashCode:function(item){if(!item){throw new ArgumentNullException({paramName:"item"});}if($is(item,Object)){return item.getHashCode();}else{if(typeof item==="object"){throw new ArgumentException({paramName:"item",message:"Type is invalid"});}}return item;}},Object,ISet);exports.Set=Set;var IDictionary=$interface({length:{get:function(){}},clear:function(){},add:function(key,value){},remove:function(key){},contains:function(key){},get:function(key){},set:function(key,value){}},IIteratable);exports.IDictionary=IDictionary;var KeyValuePair=$class({__construct__:function(key,value){if(!key){throw new ArgumentNullException("Key is not set");}this.__key=key;this.__value=value;},key:{get:function(){return this.__key;}},value:{get:function(){return this.__value;},set:function(value){this.__value=value;}}},Object);exports.KeyValuePair=KeyValuePair;var DictionaryIterator=$class({__construct__:function(items){this.__index=-1;if(!items){throw new ArgumentNullException({paramName:"items"});}this.__items=items;this.__hashCodes=global.Object.keys(items);},hasNext:function(){return this.__index+1<this.__hashCodes.length;},next:function(){if(!this.hasNext()){return null;}this.__index++;return this.__items[this.__hashCodes[this.__index]];},reset:function(){this.__index=-1;},toString:function(){return"util4js.DictionaryIterator";}},Object,IIterator);exports.DictionaryIterator=DictionaryIterator;var Dictionary=$class({__construct__:function(items){this.__items=global.Object.create(null);this.__length=0;if(items){if(items instanceof Array){for(var i=0;i<items.length;i++){if("key" in items[i]&&"value" in items[i]){this.add(items[i].key,items[i].value);}else{throw new ArgumentException({paramName:"items"});}}}else{throw new ArgumentException({paramName:"items",message:"Parameter type is invalid"});}}},toString:function(){return"util4js.Dictionary";},iterator:function(){return new DictionaryIterator(this.__items);},length:{get:function(){return this.__length;}},clear:function(){this.__length=0;this.__items={};},add:function(key,value){var hashCode=this.__getKeyHashCode(key);if(!this.contains(hashCode)){this.__items[hashCode]=new KeyValuePair(key,value);this.__length++;}else{throw new ArgumentException({paramName:"key",message:"An entry with dublicated key can't be added to the dictionary"});}},remove:function(key){var hashCode=this.__getKeyHashCode(key);if(this.contains(hashCode)){delete this.__items[hashCode];this.__length--;return true;}return false;},contains:function(key){var hashCode=this.__getKeyHashCode(key);return(hashCode in this.__items);},get:function(key){var hashCode=this.__getKeyHashCode(key);if(this.contains(hashCode)){return this.__items[hashCode].value;}else{throw new ArgumentException({paramName:"key",message:"Key doesn't exists in the dictionary"});}},set:function(key,value){var hashCode=this.__getKeyHashCode(key);if(this.contains(hashCode)){this.__items[hashCode].value=value;}else{throw new ArgumentException({paramName:"key",message:"Key doesn't exists in the dictionary"});}},__getKeyHashCode:function(key){if(!key){throw new ArgumentNullException({paramName:"key"});}if($is(key,Object)){return key.getHashCode();}else{if(typeof key==="object"){throw new ArgumentException({paramName:"key",message:"Type is invalid"});}}return key;}},Object,IDictionary);exports.Dictionary=Dictionary;var IStack=$interface({length:{get:function(){}},clear:function(){},contains:function(item){},peek:function(){},pop:function(){},push:function(item){}},IIteratable);exports.IStack=IStack;var Stack=$class({__construct__:function(items){this.__items=[];if(items){if(items instanceof Array){for(var i=0;i<items.length;i++){this.push(items[i]);}}else{throw new ArgumentException({paramName:"items",message:"Parameter type is invalid"});}}},toString:function(){return"util4js.Stack";},iterator:function(){return new Iterator(this.__items);},length:{get:function(){return this.__items.length;}},clear:function(){this.__items=[];},contains:function(item){var index;if($is(item,Object)){for(var i=0;i<this.__items.length;i++){if(Object.equals(this.__items[i],item)){index=i;break;}}}else{index=this.__items.indexOf(item);}return index!=-1;},peek:function(){if(this.__items.length==0){throw new Exception({message:"Stack is empty"});}return this.__items[this.__items.length-1];},pop:function(){if(this.__items.length==0){throw new Exception({message:"Stack is empty"});}return this.__items.pop();},push:function(item){this.__items.push(item);}},Object,IStack);exports.Stack=Stack;var IQueue=$interface({length:{get:function(){}},clear:function(){},contains:function(item){},peek:function(){},enqueue:function(item){},dequeue:function(){}});exports.IQueue=IQueue;var Queue=$class({__construct__:function(items){this.__items=[];if(items){if(items instanceof Array){for(var i=0;i<items.length;i++){this.enqueue(items[i]);}}else{throw new ArgumentException({paramName:"items",message:"Parameter type is invalid"});}}},toString:function(){return"util4js.Queue";},iterator:function(){return new Iterator(this.__items);},length:{get:function(){return this.__items.length;}},clear:function(){this.__items=[];},contains:function(item){var index;if($is(item,Object)){for(var i=0;i<this.__items.length;i++){if(Object.equals(this.__items[i],item)){index=i;break;}}}else{index=this.__items.indexOf(item);}return index!=-1;},peek:function(){if(this.__items.length==0){throw new Exception({message:"Queue is empty"});}return this.__items[0];},enqueue:function(item){this.__items.push(item);},dequeue:function(){if(this.__items.length==0){throw new Exception({message:"Queue is empty"});}return this.__items.shift();}},Object,IQueue);exports.Queue=Queue;$extend(IIteratable,"forEach",function(callback){if(callback){var iterator=this.iterator();while(iterator.hasNext()){callback(iterator.next());}}});$extend(IIteratable,"count",function(){var count=0;var iterator=this.iterator();while(iterator.next()){count++;}return count;});$extend(IIteratable,"first",function(){var iterator=this.iterator();var first=null;while(iterator.hasNext()){first=iterator.next();break;}return first;});$extend(IIteratable,"last",function(){var iterator=this.iterator();var last=null;while(iterator.hasNext()){last=iterator.next();}return last;});$extend(IIteratable,"toArray",function(){var array=[];var iterator=this.iterator();while(iterator.hasNext()){array.push(iterator.next());}return array;});$extend(IIteratable,"toList",function(){var list=new List();while(iterator.hasNext()){list.add(iterator.next());}return list;});var Event=$class({__construct__:function(){this.__target=null;this.__type="";},type:{get:function(){return this.__type;},set:function(value){this.__type=value;}},target:{get:function(){return this.__target;},set:function(value){this.__target=value;}},toString:function(){return this.type;}},Object);exports.Event=Event;var IEventTarget=$interface({addEventListener:function(type,listener){},removeEventListener:function(type,listener){},dispatchEvent:function(e){}});exports.IEventTarget=IEventTarget;var EventDispathcer=$class({__construct__:function(){this.__listeners=new Dictionary();},add:function(type,listener){if(!type){throw new ArgumentNullException({paramName:"type"});}if(typeof type!=="string"){throw new ArgumentException({paramName:"type",message:"Type is invalid"});}if(!listener){throw new ArgumentNullException({paramName:"listener"});}if(typeof listener!=="function"){throw new ArgumentException({paramName:"listener",message:"Type is invalid"});}if(this.__listeners.contains(type)){this.__listeners.get(type).add(listener);}else{this.__listeners.add(type,new List([listener]));}},remove:function(type,listener){if(!type){throw new ArgumentNullException({paramName:"type"});}if(typeof type!=="string"){throw new ArgumentException({paramName:"type",message:"Type is invalid"});}if(!listener){throw new ArgumentNullException({paramName:"listener"});}if(typeof listener!=="function"){throw new ArgumentException({paramName:"listener",message:"Type is invalid"});}return this.__listeners.get(type).remove(listener);},dispatch:function(e){if(!e){throw new ArgumentNullException({paramName:"e"});}if($is(e,Event)){this.__listeners.get(e.type).forEach(function(callback){callback.call(e.target,e);});}else{throw new ArgumentException({paramName:"e",message:"Parameter type is invalid"});}},toString:function(){return"util4js.EventDispathcer";}},Object);exports.EventDispathcer=EventDispathcer;var Component=$abstract_class({__construct__:function(){this.__eventDispatcher=new EventDispathcer();},addEventListener:function(type,listener){this.__eventDispatcher.add(type,listener);},removeEventListener:function(type,listener){this.__eventDispatcher.remove(type,listener);},dispatchEvent:function(e){this.__eventDispatcher.dispatch($create(Event,e));},toString:function(){return"util4js.Component";}},Object,IEventTarget);exports.Component=Component;},[window]);